// optimizer.cpp : Defines the entry point for the console application.
//

#if HAVE_CONFIG_H
        #include <config.h>
#endif

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>

#include "POptimizerGAoptimizer.h"
#include "POptimizerParameters.h"
#include "POptimizerCommon.h"

using namespace POptimizer;

int main(int argc, char* argv[])
{
	char allvarvaluestr[500];
	char st[100];
	int i;

	// parse command line and read in parameters
	if(argc == 1)
		fprintf(stderr, "poptimizer version %s\n", VERSION);
	POptimizerParameters parameterset;
	parameterset.read(argc, argv);

	if(strcmp(parameterset.para_opti_algo,"DE")==0)
		paraoptimethodno=1;
	if(strcmp(parameterset.para_opti_algo,"GA")==0)
		paraoptimethodno=2;
	if(strcmp(parameterset.para_opti_algo,"EDA")==0)
		paraoptimethodno=3;
	if(strcmp(parameterset.para_opti_algo,"CMA-ES")==0)
		paraoptimethodno=4;

	if(strcmp(parameterset.fitness_func_type,"EqualWeightedSum")==0)
		methodno=1;
	if(strcmp(parameterset.fitness_func_type,"RandomWeightedSum")==0)
		methodno=2;

	initsetnum=parameterset.num_initials;
	if(initsetnum==1)
	{
		strcpy(multiinputfile[0],parameterset.target_file);
		strcpy(multiinitfile[0],parameterset.initial_file);
	}
	else
	{
		for(i=0;i<initsetnum;i++)
		{
			sprintf(st,"%s%d.txt",parameterset.target_file,i+1);
			strcpy(multiinputfile[i],st);
			sprintf(st,"%s%d.txt",parameterset.initial_file,i+1);
			strcpy(multiinitfile[i],st);
		}
	}
	strcpy(library_file,parameterset.nonfix_module_lib_file);
	if( debug_mode )
		printf("input non-fix module library file:%s\n",library_file);
	strcpy(fixlibrary_file,parameterset.fix_module_lib_file);
	if(strcmp(fixlibrary_file,"Null")==0)
		flagfixlib=0;
	else
	{
		flagfixlib=1;
		if( debug_mode )
			printf("input fix module library file:%s\n",fixlibrary_file);
	}

	targetobjnum=parameterset.target_obj_num;
	maxtime=parameterset.maxtime;
	interval=parameterset.interval;
	maxmodulesno=parameterset.maxmodulesno;
	runs=parameterset.simu_runs;
	seednum=parameterset.seednum;
	show_progress=parameterset.show_progress;
	debug_mode=parameterset.debug_mode;
	popsize=parameterset.popsize;
	maxgeno=parameterset.maxgeno;
	maxop=(int)(parameterset.popsize*parameterset.percent_paraopti);

	DEpsize=parameterset.DE_psize;
	DEmaxgeno=parameterset.DE_maxgeno;

	GApsize=parameterset.GA_psize;
	GAmaxxo=parameterset.GA_maxxo;

	EDApsize=parameterset.EDA_psize;
	EDAmaxgeno=parameterset.EDA_maxgeno;

	CMAESmaxgeno=parameterset.CMAES_maxgeno;

	strcpy(allvarvaluestr,parameterset.molecules);
	get_allobjects_valuename(allvarvaluestr,':');

	GAoptimizer GA;
	GA.execute();
}

