// GAoptimizer class definitions
/* Date (yymmdd):               081215
 * Version:                     0.1
 * Written by:                  Hongqing Cao
 * Additional contributions by: 
				Dr. Francisco Jos Romero Campero
				Jonathan Blakes				
				Dr. Jamie Twycross
 *                              Dr. Natalio Krasnogor
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
*/ 

#ifndef GAOPTIMIZER_H
#define GAOPTIMIZER_H

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <stdlib.h> 
#include <string.h>

#include "POptimizerCommon.h"
#include "POptimizerRule.h"
#include "POptimizerModule.h"
#include "POptimizerMembrane.h"

#include <fstream>
#include <iostream>
#include <string>
#include <sstream>
#include <ostream>
#include <map>

#include <libxml++/libxml++.h>
#include <ecsb/ecsb.h>

using namespace ECSB;

namespace POptimizer {

class GAoptimizer
{
protected:
	void sigintHandler(void);  // handle INT signal
	void sigusr1Handler(void);  // handle USR1 signal
public:
	Membrane *popu,*newpopu,*diffpopu,*twopopu;
	float *fitness,*newfitness,*twofitness,*difffitness;
	float *crate,*mrate;

	Membrane tempmembrane;

	GAoptimizer();
	virtual ~GAoptimizer();
	void execute(void);
};
}
#endif

