// Rule class definitions
/* Date (yymmdd):               081215
 * Version:                     0.1
 * Written by:                  Hongqing Cao
 * Additional contributions by: 
				Dr. Francisco Jos Romero Campero
				Jonathan Blakes				
				Dr. Jamie Twycross
 *                              Dr. Natalio Krasnogor
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
*/ 

#ifndef RULE_H
#define RULE_H

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <stdlib.h> 
#include <string.h>

#include "POptimizerCommon.h"
namespace POptimizer {
class Rule 
{
public:
	char name[10];	
	int objfixflag;
	int lonum;
   	int ronum;
	
	char lowithvar[4][30];
	char rowithvar[4][30];
	char lowithvalue[4][30];
	char rowithvalue[4][30];
	int kcfixflag;
	float kclowerb;
	float kcupperb;
	float kcprecision; 
	int kcsigdigit; 
	char kcscale[20];	
	float kcvalue;

	Rule();
	virtual ~Rule();
	int check_same_singlerule(Rule r1,Rule r2);
	void display_singlerule(Rule rule);
	int simplify_ruleset(Rule *totalr,int rnum);
	int get_objects_in_ruleset(Rule *rules, int rnum, int nonzobjnum, char nonzobjname[50][50], float nonzobjinit[50]);
	int Gillespie_algorithm(Rule *totalruns, int totalrulesnum,float **outputobj);
};
}
#endif

